diff -urN src/gtk2/gui/guiNetHtmlScanner.mll src/gtk2/gui/guiNetHtmlScanner.mll
--- src/gtk2/gui/guiNetHtmlScanner.mll	1970-01-01 01:00:00.000000000 +0100
+++ src/gtk2/gui/guiNetHtmlScanner.mll	2005-07-26 06:43:36.000000000 +0200
@@ -0,0 +1,164 @@
+(* $Id: nethtml_scanner.mll,v 2.2 2002/07/06 16:24:44 stolpmann Exp $
+ * ----------------------------------------------------------------------
+ *
+ *)
+
+{
+  type token =
+      Lcomment  (* <!-- *)
+    | Rcomment  (* --> *)
+    | Mcomment  (* within comment *)
+    | Ldoctype  (* <! *)
+    | Rdoctype  (* > *)
+    | Mdoctype  (* within declaration *)
+    | Lpi       (* <? *)
+    | Rpi       (* ?> or > *)
+    | Mpi       (* within processing instruction *)
+    | Lelement of string
+    | Lelementend of string
+    | Relement
+    | Cdata of string 
+    | Space of int
+    | Name of string
+    | Is
+    | Literal of string
+    | Other
+    | Eof
+}
+
+(* Simplified rules: Only ASCII is recognized as character set *)
+
+let letter = ['A'-'Z' 'a'-'z' ]
+let digit = ['0'-'9']
+let hexdigit = ['0'-'9' 'A'-'F' 'a'-'f']
+let namechar = letter | digit | '.' | ':' | '-' | '_'
+let name = ( letter | '_' | ':' ) namechar*
+let nmtoken = namechar+
+let ws = [ ' ' '\t' '\r' '\n' ]
+let string_literal1 = '"' [^ '"' ]* '"'
+let string_literal2 = "'" [^ '\'' ]* "'"
+let string_literal3 = [^ '"' '\'' '>' '=' ' ' '\t' '\n' '\r' ]+
+
+(* This following rules reflect HTML as it is used, not the SGML
+ * rules.
+ *)
+
+rule scan_document = parse
+  | "<!--"
+      { Lcomment }
+  | "<!"
+      { Ldoctype }
+  | "<?"
+      { Lpi }
+  | "<" name
+      { let s = Lexing.lexeme lexbuf in
+	Lelement (String.sub s 1 (String.length s - 1))
+      }
+  | "</" name
+      { let s = Lexing.lexeme lexbuf in
+	Lelementend (String.sub s 2 (String.length s - 2))
+      }
+  | "<"                (* misplaced "<" *)
+      { Cdata "<" }
+  | eof
+      { Eof }
+  | [^ '<' ]+
+      { Cdata (Lexing.lexeme lexbuf)}
+
+and scan_special = parse
+  | "</" name 
+      { let s = Lexing.lexeme lexbuf in
+	Lelementend (String.sub s 2 (String.length s - 2))
+      }
+  | "<"
+      { Cdata "<" }
+  | eof
+      { Eof }
+  | [^ '<' ]+
+      { Cdata (Lexing.lexeme lexbuf)}
+
+
+and scan_comment = parse
+  | "-->"
+      { Rcomment }  (* FIXME: There may be any number of ws between -- and > *)
+  | "-"
+      { Mcomment }
+  | eof
+      { Eof }
+  | [^ '-']+
+      { Mcomment }
+
+and scan_doctype = parse
+  | ">"                   (* Occurence in strings, and [ ] brackets ignored *)
+      { Rdoctype }
+  | eof
+      { Eof }
+  | [^ '>' ] +
+      { Mdoctype }
+
+and scan_pi = parse
+  | "?>"
+      { Rpi }
+  | ">"
+      { Rpi }
+  | eof
+      { Eof }
+  | '?' 
+      { Mpi }
+  | [^ '>' '?' ] +
+      { Mpi }
+
+and scan_element = parse
+  | ">"
+      { Relement }
+  | ws+
+      { Space (String.length (Lexing.lexeme lexbuf)) }
+  | name
+      { Name (Lexing.lexeme lexbuf) }
+  | "="
+      { Is }
+  | string_literal1
+      { let s = Lexing.lexeme lexbuf in
+	Literal (String.sub s 1 (String.length s - 2)) 
+      }
+  | string_literal2
+      { let s = Lexing.lexeme lexbuf in
+	Literal (String.sub s 1 (String.length s - 2)) 
+      }
+  | string_literal3
+      { Literal (Lexing.lexeme lexbuf) }
+  | eof
+      { Eof }
+  | _
+      { Other }
+
+(* ======================================================================
+ * History:
+ * 
+ * $Log: nethtml_scanner.mll,v $
+ * Revision 2.2  2002/07/06 16:24:44  stolpmann
+ * 	Change: Only ASCII letters are accepted in names.
+ *
+ * Revision 2.1  2001/09/14 14:22:34  stolpmann
+ * 	Initial revision (sourceforge)
+ *
+ *
+ * ======================================================================
+ * Revision 1.4  2001/07/15 14:18:34  gerd
+ * 	Attribute parsing is now less strict.
+ *
+ * Revision 1.3  2001/06/08 16:25:27  gerd
+ * 	Bugfix: </SCRIPT> is now recognized (thanks to David Fox)
+ * 	The parser may now return comments, declarations, and processing
+ * instructions if requested to do so
+ * 	The parser accepts xhtml to some extent
+ * 	Now exported: parse_document.
+ *
+ * Revision 1.2  2001/04/24 19:27:00  gerd
+ * 	Added a FIXME comment
+ *
+ * Revision 1.1  2000/03/03 01:07:25  gerd
+ * 	Initial revision.
+ *
+ * 
+ *)
diff -urN src/gtk2/gui/guiNetworks.ml src/gtk2/gui/guiNetworks.ml
--- src/gtk2/gui/guiNetworks.ml	2005-03-02 20:45:11.000000000 +0100
+++ src/gtk2/gui/guiNetworks.ml	2005-10-23 14:27:33.000000000 +0200
@@ -50,18 +50,6 @@
   (if !!verbose then lprintf' "Enable network %d %b\n" num b);
   GuiCom.send (EnableNetwork (num, b))
 
-let update_networks () = ()
-(*
-TODO :
-  the core should update the values ... but it doesn't
-    Hashtbl.iter (fun num n ->
-      (* Printf.printf "Update network %d %b\n" num n.net_enabled;
-      flush stdout; *)
-      if n.net_enabled
-        then GuiCom.send (GetNetworkInfo num)
-  ) G.networks
-*)
-
 (*************************************************************************)
 (*                                                                       *)
 (*                         Global tables                                 *)
@@ -334,12 +322,4 @@
          n := 0;
        end
   ) net_list;
-  (*
-  networks_timerID := Timeout.add ~ms:6000 ~callback:
-    (fun _ ->
-      (* Printf.printf "Update networks\n";
-      flush stdout; *)
-      update_networks ();
-      true);
-*)
   vbox#coerce
diff -urN src/gtk2/gui/guiOptions.ml src/gtk2/gui/guiOptions.ml
--- src/gtk2/gui/guiOptions.ml	2005-08-05 02:56:13.000000000 +0200
+++ src/gtk2/gui/guiOptions.ml	2005-10-23 14:35:49.000000000 +0200
@@ -22,6 +22,7 @@
 open Gettext
 open Options
 open CommonGlobals
+open GraphTypes
 
 module U = GuiUtf8
 
@@ -40,10 +41,10 @@
 module M = GuiMessages
 module C = GuiColumns
 
-let _ = Unix2.safe_mkdir CommonOptions.home_dir
-  
-let gui_ini = create_options_file 
-    (Filename.concat CommonOptions.home_dir "mlgui.ini")
+let _ = Unix2.safe_mkdir GuiMessages.gui_config_dir
+
+let gui_ini = create_options_file
+    (Filename.concat GuiMessages.gui_config_dir "mlgui.ini")
 
 
 
@@ -72,6 +73,38 @@
     define_option_class "Toolbar" 
     value_to_tbstyle tbstyle_to_value
 
+let graphtime_to_string gt =
+  match gt with
+      GraphHour -> "hour"
+    | GraphHalfDay -> "half_day"
+    | GraphDay -> "day"
+    | GraphWeek -> "week"
+    | GraphMonth -> "month"
+    | GraphYear -> "year"
+    | _ -> "quarter"
+
+let string_to_graphtime s =
+  match s with
+      "hour" -> GraphHour
+    | "half_day" -> GraphHalfDay
+    | "day" -> GraphDay
+    | "week" -> GraphWeek
+    | "month" -> GraphMonth
+    | "year" -> GraphYear
+    | _ -> GraphQuarter
+
+let value_to_graphtime v =
+  match v with
+      StringValue s -> string_to_graphtime s
+    | _ -> GraphQuarter
+
+let graphtime_to_value (gt : graph_time) =
+  StringValue (graphtime_to_string gt)
+
+let (graphtime_option : graph_time option_class) =
+    define_option_class "GraphTime" 
+    value_to_graphtime graphtime_to_value
+
 let time_option =
     define_option_class "Time"
     value_to_int int_to_value
@@ -113,6 +146,26 @@
 
 let current_section = mlgui_section
 
+(* {Connection} *)
+
+let gtk_connection_http_proxy_server = define_option current_section
+    ["gtk_connection_http_proxy_server"]
+    ~desc:"HTTP proxy server"
+    "Direct HTTP queries to HTTP proxy"
+    string_option ""
+
+let gtk_connection_http_proxy_port = define_option current_section
+    ["gtk_connection_http_proxy_port"]
+    ~desc:"HTTP proxy server port"
+    "Port of HTTP proxy"
+    int_option 8080
+
+let gtk_connection_http_use_proxy = define_option current_section
+    ["gtk_connection_http_use_proxy"]
+    ~desc:"Enable Proxy server"
+    "Direct TCP connections to HTTP proxy (the proxy should support CONNECT)"
+    bool_option false
+
 (* {Client} *)
 
 let gtk_client_login = define_option current_section
@@ -246,33 +299,43 @@
     font_option "sans 16"
 
 
-(* TODO : Graph options! *)
-
 (* {2 Graph Options} *)
-(*
-let gtk_graph_time_range =  define_option current_section 
-    ["gtk_graph_time_range"]
-    ~desc:"Time range"
-    "Set the time range for both the uploads and downloads graphs"
-    time_option 21600
+
+let gtk_graph_time_downloads =  define_option current_section
+    ["gtk_graph_time_downloads"]
+    ~desc:"Time range to view the global downloads"
+    "Set the time range for the downloads graph"
+    graphtime_option GraphQuarter
+
+let gtk_graph_time_uploads =  define_option current_section
+    ["gtk_graph_time_uploads"]
+    ~desc:"Time range to view the global uploads"
+    "Set the time range for the uploads graph"
+    graphtime_option GraphQuarter
+
+let gtk_graph_time_file =  define_option current_section
+    ["gtk_graph_time_file"]
+    ~desc:"Time range to view one-file downloads and uploads"
+    "Set the time range to display the uploads and downloads of one file in the graph tab"
+    graphtime_option GraphQuarter
 
 let gtk_graph_font = define_option current_section
     ["gtk_graph_font"]
     ~desc:"Font"
     "Set the font to display texts in both the uploads and downloads graphs" 
-    font_option "sans 8"
+    font_option "sans 7"
 
 let gtk_graph_background =  define_option current_section 
     ["gtk_graph_background"]
     ~desc:"Background color"
     "Set the background color for both the uploads and downloads graphs" 
-    color_option "#454b55"
+    color_option "#000000"
 
 let gtk_graph_grid =  define_option current_section 
     ["gtk_graph_grid"]
     ~desc:"Grid color"
     "Set the color of the grid for both the uploads and downloads graphs" 
-    color_option "#fffcc6"
+    color_option "#484848"
 
 let gtk_graph_download = define_option current_section 
     ["gtk_graph_download"]
@@ -286,22 +349,15 @@
     "Set the foreground color of the upload rate"
     color_option "#6eec8b"
 
-let gtk_graph_download_av = define_option current_section 
-    ["gtk_graph_download_av"]
-    ~desc:"Average downloads color"
-    "Set the foreground color of the average download rate" 
-    color_option "#2d62c1"
-
-let gtk_graph_upload_av = define_option current_section 
-    ["gtk_graph_upload_av"]
-    ~desc:"Average uploads color"
-    "Set the foreground color of the average upload rate"
-    color_option "#61b722"
-*)
-
 
 (* {Misc} *)
 
+let gtk_misc_display_razorback_stats = define_option current_section
+    ["gtk_misc_display_razorback_stats"]
+    ~desc:"Display razorback statistics"
+    "Check to display file information from http://stats.razorback2.com in the downloads page"
+    bool_option true
+
 let gtk_misc_relative_availability = define_option current_section 
     ["gtk_misc_relative_availability"]
     ~desc:"Use relative % availability"
@@ -311,7 +367,7 @@
 let gtk_misc_files_auto_expand_depth = define_option current_section 
     ["gtk_misc_files_auto_expand_depth"]
     ~desc:"Files auto-expand depth"
-    "The depth to which the directories of a friend are automatically expanded" 
+    "The depth to which the directories of a friend are automatically expanded"
     int_option 3
 
 let gtk_misc_use_availability_height = define_option current_section 
@@ -667,6 +723,12 @@
     "Debug module GuiConsole"
     bool_option false
 
+let gtk_verbose_graphbase = define_expert_option current_section
+    ["gtk_verbose_graphbase"]
+    ~desc:"verbose graphbase"
+    "Debug module GuiGraphBase"
+    bool_option false
+
 let gtk_verbose_graph = define_expert_option current_section
     ["gtk_verbose_graph"]
     ~desc:"verbose graph"
diff -urN src/gtk2/gui/guiQueries.ml src/gtk2/gui/guiQueries.ml
--- src/gtk2/gui/guiQueries.ml	2005-03-02 20:45:11.000000000 +0100
+++ src/gtk2/gui/guiQueries.ml	2005-10-12 00:08:49.000000000 +0200
@@ -369,10 +369,14 @@
   qr.g_query_label <- Some label;
   qr.g_query_waiting_label <- Some query_status;
   let on_closure () =
+    let results = GuiResults.keys_to_results (qr.g_query_result#all_items ()) in
+    List.iter (fun r ->
+      Hashtbl.remove G.results r.res_num;
+    ) results;
     close_query qr.g_query_num true;
     qr.g_query_result#clear ();
     main_evbox#destroy ();
-    Hashtbl.remove qresults qr.g_query_num
+    Hashtbl.remove qresults qr.g_query_num;
   in
   GuiTools.add_key ~key:GdkKeysyms._w ~target:main_evbox ~f:on_closure ~mods:[`CONTROL] ();
   ignore (evbox#event#connect#button_press ~callback:
@@ -919,7 +923,6 @@
     try
       let r = Hashtbl.find G.results result_num in
       ignore (qr.g_query_result#add_item r);
-      Hashtbl.remove G.results result_num; (* remove the result from G.users once it is stored *)
       let text = Printf.sprintf "%s (%d)" qr.g_query_desc qr.g_query_result#nitems in
       match qr.g_query_label with
           None -> ()
diff -urN src/gtk2/gui/guiResults.ml src/gtk2/gui/guiResults.ml
--- src/gtk2/gui/guiResults.ml	2005-04-04 21:36:46.000000000 +0200
+++ src/gtk2/gui/guiResults.ml	2005-09-17 14:15:59.000000000 +0200
@@ -42,19 +42,66 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         result_num                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let result_num key =
+  try int_of_string key with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         result_of_key                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let result_of_key key =
+  try
+    let num = result_num key in
+    Hashtbl.find G.results num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_results                               *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_results keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = result_of_key k in
+      l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         result_key                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let result_key result_num =
+  Printf.sprintf "%d" result_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         message to the core                           *)
 (*                                                                       *)
 (*************************************************************************)
 
 let download sel () =
+  let l = keys_to_results sel in
   List.iter (fun r -> 
     GuiCom.send (Download_query ([r.res_name], r.res_num, false))
-  ) sel
+  ) l
 
 let force_download sel () =
+  let l = keys_to_results sel in
   List.iter (fun r -> 
     GuiCom.send (Download_query ([r.res_name], r.res_num, true))
-  ) sel
+  ) l
 
 (*************************************************************************)
 (*                                                                       *)
@@ -62,7 +109,7 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let result_menu (sel : res_info list) =
+let result_menu sel =
   match sel with
       [] -> []
     | _ ->
@@ -77,9 +124,11 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let filter_result (r : res_info) =
-  not (List.memq r.res_network !G.networks_filtered)
-
+let filter_result k =
+  try
+    let r = result_of_key k in
+    not (List.memq r.res_network !G.networks_filtered)
+  with _ -> true
 
 
 module ResultList(Res:
@@ -114,10 +163,9 @@
     module Column = GuiColumns.Result
 
     type item = res_info
-    type key = int
 
     let columns = Res.columns
-    let get_key = (fun r -> r.res_num)
+    let get_key = (fun r -> result_key r.res_num)
     let module_name = Res.module_name
 
   end)
@@ -322,8 +370,11 @@
 (*                                                                       *)
 (*************************************************************************)
 
-      method sort_items c r1 r2 =
-        match c with
+      method sort_items c k1 k2 =
+        try
+          let r1 = result_of_key k1 in
+          let r2 = result_of_key k2 in
+          match c with
             Col_result_name -> compare (String.lowercase r1.res_name) (String.lowercase r2.res_name)
           | Col_result_uid -> compare r1.res_uid r2.res_uid
           | Col_result_size -> compare r1.res_size r2.res_size
@@ -337,7 +388,7 @@
           | Col_result_comment -> compare r1.res_comment r2.res_comment
           | Col_result_network -> compare r1.res_network r2.res_network
           | Col_result_completesources -> compare r1.res_completesources r2.res_completesources
-
+        with _ -> 0
 
 (*************************************************************************)
 (*                                                                       *)
@@ -346,9 +397,10 @@
 (*************************************************************************)
 
     method force_update_icons () =
-      List.iter (fun r ->
+      List.iter (fun k ->
         try
-          let (row, _) = self#find_item r.res_num in
+          let r = result_of_key k in
+          let row = self#find_row k in
           r.res_network_pixb <- Mi.network_pixb r.res_num ~size:A.SMALL ();
           r.res_name_pixb <- Mi.file_type_of_name r.res_name ~size:A.SMALL;
           store#set ~row ~column:result_network_pixb r.res_network_pixb;
diff -urN src/gtk2/gui/guiRooms.ml src/gtk2/gui/guiRooms.ml
--- src/gtk2/gui/guiRooms.ml	2005-03-02 20:45:11.000000000 +0100
+++ src/gtk2/gui/guiRooms.ml	2005-09-17 14:44:45.000000000 +0200
@@ -47,6 +47,51 @@
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         room_num                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let room_num key =
+  try int_of_string key with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         room_of_key                                   *)
+(*                                                                       *)
+(*************************************************************************)
+
+let room_of_key key =
+  try
+    let num = room_num key in
+    Hashtbl.find G.rooms num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_rooms                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_rooms keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = room_of_key k in
+      l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         room_key                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let room_key room_num =
+  Printf.sprintf "%d" room_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         Global tables                                 *)
 (*                                                                       *)
 (*************************************************************************)
@@ -89,10 +134,9 @@
   module Column = GuiColumns.Room
 
   type item = room_info
-  type key = int
 
   let columns = O.rooms_columns
-  let get_key = (fun r -> r.room_num)
+  let get_key = (fun r -> room_key r.room_num)
   let module_name = "Rooms"
 
 end)
@@ -209,12 +253,16 @@
 (*                                                                       *)
 (*************************************************************************)
 
-    method sort_items c ro1 ro2 =
-      match c with
+    method sort_items c k1 k2 =
+      try
+        let ro1 = room_of_key k1 in
+        let ro2 = room_of_key k2 in
+        match c with
           Col_room_name -> compare (String.lowercase ro1.room_name) (String.lowercase ro2.room_name)
         | Col_room_nusers -> compare ro1.room_nusers ro2.room_nusers
         | Col_room_state -> compare ro1.room_state ro2.room_state
         | Col_room_network -> compare ro1.room_network ro2.room_network
+      with _ -> 0
 
 (*************************************************************************)
 (*                                                                       *)
@@ -223,9 +271,10 @@
 (*************************************************************************)
 
     method force_update_icons () =
-      List.iter (fun ro ->
+      List.iter (fun k ->
         try
-          let (row, _) = self#find_item ro.room_num in 
+          let row = self#find_row k in
+          let ro = room_of_key k in
           store#set ~row ~column:room_network_pixb (Mi.network_pixb ro.room_network ~size:A.SMALL ());
           store#set ~row ~column:room_name_pixb (Mi.room_state_to_icon ro.room_state ~size:A.SMALL);
         with _ -> ()
@@ -279,11 +328,12 @@
 (*************************************************************************)
 
 let close_open_room sel () =
+  let l = keys_to_rooms sel in
   List.iter (fun ro ->
     match ro.room_state with
         RoomOpened -> GuiCom.send (SetRoomState (ro.room_num, RoomClosed))
       | _ -> GuiCom.send (SetRoomState (ro.room_num, RoomOpened))
-  ) sel
+  ) l
 
 let on_entry_return num s =
   GuiCom.send (SendMessage (num, PublicMessage (0, s)))
@@ -297,7 +347,7 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let room_menu (sel : room_info list) =
+let room_menu sel =
   match sel with
       [] -> []
     | _ ->
@@ -311,7 +361,7 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let on_select_room (sel : room_info list) =
+let on_select_room sel =
   try
     userstore#clear ();
     update_users_label ();
@@ -323,28 +373,29 @@
     in
     match sel with
         [] -> (if !!verbose then lprintf' "No room selected\n")
-      | ro :: tail ->
+      | k :: tail ->
           begin
-            current_room := Some ro.room_num;
-            match ro.room_state with
-                RoomOpened  ->
-                  begin
-                    List.iter (fun user_num ->
+            try
+              let ro = room_of_key k in
+              current_room := Some ro.room_num;
+              match ro.room_state with
+                  RoomOpened  ->
+                    begin
+                      List.iter (fun user_num ->
+                        try
+                          let u = Hashtbl.find G.users user_num in
+                          ignore (userstore#add_item u);
+                        with _ -> get_user_info user_num
+                      ) ro.room_users;
+                      update_users_label ();
                       try
-                        let u = Hashtbl.find G.users user_num in
-                        ignore (userstore#add_item u);
-                      with _ -> get_user_info user_num
-                    ) ro.room_users;
-                    update_users_label ();
-                    try
-                      let chat_buf = List.assoc ro.room_num !dialogs in
-                      box#set_buffer chat_buf
-                    with _ -> (if !!verbose then lprintf' "No chat dialog availabale\n")
-                  end
-              | _  -> (if !!verbose then lprintf' "room_users empty\n")
-
+                        let chat_buf = List.assoc ro.room_num !dialogs in
+                        box#set_buffer chat_buf
+                      with _ -> (if !!verbose then lprintf' "No chat dialog availabale\n")
+                    end
+                | _  -> (if !!verbose then lprintf' "room_users empty\n")
+            with _ -> ()
           end
-
   with _ -> (if !!verbose then lprintf' "No chat_box found\n")
 
 (*************************************************************************)
@@ -353,8 +404,8 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let on_double_click_room (ro : room_info) =
-  close_open_room [ro] ()
+let on_double_click_room k =
+  close_open_room [k] ()
 
 (*************************************************************************)
 (*                                                                       *)
@@ -362,8 +413,11 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let filter_room (ro : room_info) =
-  not (List.memq ro.room_network !G.networks_filtered)
+let filter_room k =
+  try
+    let ro = room_of_key k in
+    not (List.memq ro.room_network !G.networks_filtered)
+  with _ -> true
 
 (*************************************************************************)
 (*                                                                       *)
@@ -403,6 +457,12 @@
 (*                                                                       *)
 (*************************************************************************)
 
+let hashtbl_rooms_update ro ro_new =
+  ro.room_state <- ro_new.room_state;
+  ro.room_users <- ro_new.room_users;
+  ro.room_messages <- ro_new.room_messages;
+  ro.room_nusers <- ro_new.room_nusers
+
 let add_chat_to_room ro =
   match ro.room_state with
       RoomOpened ->
@@ -440,18 +500,21 @@
       (if !!verbose then lprintf' "Adding room %s num: %d\n" ro.room_name ro.room_num);
       add_chat_to_room ro;
       ignore (roomstore#add_item ro);
+      Hashtbl.add G.rooms ro.room_num ro;
       update_rooms_label ()
     end
 
 let room_info r =
   try
     (if !!verbose then lprintf' "Room_info of %s\n" r.room_name);
-    let (row, ro) = roomstore#find_item r.room_num in
+    let ro = Hashtbl.find G.rooms r.room_num in
+    let row = roomstore#find_row (room_key r.room_num) in
     (* no need to keep ro.room_messages, it is stored in dialogs *)
     let ro_new = {r with room_users = ro.room_users} in
     (if ro_new.room_state <> ro.room_state
       then add_chat_to_room ro_new);
-    roomstore#update_item row ro ro_new
+    roomstore#update_item row ro ro_new;
+    hashtbl_rooms_update ro ro_new
   with _ -> add_room r
 
 let find_user_name user_num =
@@ -495,7 +558,8 @@
 let remove_room_user room_num user_num =
   (if !!verbose then lprintf' "Removing user to room %d\n" room_num);
   try
-    let (row, ro) = roomstore#find_item room_num in
+    let ro = Hashtbl.find G.rooms room_num in
+    let row = roomstore#find_row (room_key room_num) in
     (if List.mem user_num ro.room_users
       then ro.room_users <- List.filter (fun n -> n <> user_num) ro.room_users);
     let _ =
@@ -504,7 +568,7 @@
              begin
                try
                  let u = Hashtbl.find G.users user_num in
-                 userstore#remove_item u;
+                 userstore#remove_item (GuiUsers.user_key user_num);
                  update_users_label ();
                with _ -> ()
              end
@@ -520,7 +584,8 @@
 let add_room_user room_num user_num =
   (if !!verbose then lprintf' "Adding user to room %d\n" room_num);
   try
-    let (row, ro) = roomstore#find_item room_num in
+    let ro = Hashtbl.find G.rooms room_num in
+    let row = roomstore#find_row (room_key room_num) in
     (if not (List.mem user_num ro.room_users)
       then ro.room_users <- user_num :: ro.room_users);
     match (!current_room, ro.room_state) with
@@ -545,12 +610,14 @@
       Some room_num ->
          begin
            try
-             let (_, ro) = roomstore#find_item room_num in
+             let ro = Hashtbl.find G.rooms room_num in
              if List.mem u_new.user_num ro.room_users
                then begin
                  try
-                   let (row, u) = userstore#find_item u_new.user_num in
-                   userstore#update_item row u u_new
+                   let u = Hashtbl.find G.users u_new.user_num in
+                   let row = userstore#find_row (GuiUsers.user_key u_new.user_num) in
+                   userstore#update_item row u u_new;
+                   GuiUsers.hashtbl_users_update u u_new
                  with _ -> ()
                end
            with _ -> ()
